
#include <APM_RC.h>
#define ROLL 0
#define PITCH 1
#define YAW 2
#define AXIS 3
#define THROTTLE 0
#define SERVO 3
unsigned long time, oldtime,summtime,counter,Dt;   
float oldomega[AXIS];
int angle[AXIS];
int adress;
int callcheck;
float Ipart[AXIS];
double Dpart[AXIS];
float oldangle[AXIS];
int axisPID[AXIS];
int RC[AXIS];
float Pgain[AXIS];
float Igain[AXIS]; 
float Dgain[AXIS]; 
float delta1[AXIS];
float delta2[AXIS];
int motor[AXIS+1];
float des_yaw;
const int pin[3] = {A2,A1,A3};                 
double bias[3];
float omega[3];
float gain[3] = {0.6, 0.6, 0.6};


void PIDToMotor()
{
   motor[SERVO]=1500+axisPID[YAW];
   motor[0] = 1500 + RC[THROTTLE] + (axisPID[PITCH])*4/3 ; // rear motor *4/3
   motor[1] = 1500 + RC[THROTTLE] - (axisPID[ROLL])- (axisPID[PITCH])*2/3 ; // right motor  
   motor[2] = 1500 + RC[THROTTLE] + (axisPID[ROLL]) -(axisPID[PITCH])*2/3 ; // left motor
}
void Bias() // CALL IN SETUP
{
   for( int i=0;i<3;++i)
  {
    double tmp=0;
    for ( int j=0; j<100 ; ++j)
    {
      tmp+=analogRead(pin[i]);
      delay(10);
    }
    bias[i]=tmp/100.0;
  }
}
  
void GetOmega()
{
  for( int i=0; i<3; i++)
  {
    float tmp=0;
      for(int j=0;j<10;j++)
      {
          tmp+=analogRead(pin[i]);// oversampling
      }
   tmp/=10.0;
   omega[i]=(tmp-bias[i])*gain[i];
  }
}


void setup()
{  

  APM_RC.Init();
  Bias();
  Serial.begin(57600);
  Pgain[YAW]=3;
  Igain[YAW]=0;
  Dgain[YAW]=0;
  
  Igain[ROLL]=0;
  Pgain[ROLL]=0.7;
  Dgain[ROLL]=0;
  
  Pgain[PITCH]=0.7;
  Igain[PITCH]=0;
  Dgain[PITCH]=0;
  time=micros();  
}

void loop()
{
  
  /* Igain[YAW]=0;//(APM_RC.InputCh(1)-1000)/float(2000);
   Pgain[YAW]=(APM_RC.InputCh(4)-1000)/float(200);
   Dgain[YAW]=((APM_RC.InputCh(5)-1000)/float(500));
   Serial.print(Pgain[YAW]);
   Serial.print("    ");     
   Serial.print(Dgain[YAW]);
   Serial.print("    ");     
   Serial.print(Igain[YAW]);
   Serial.println("    ");   */
    GetRC();
    GetOmega();
    oldtime=time;
    time=millis();
    Dt=time-oldtime;
    summtime+=Dt;    
    float error;
    float delta;
    int i; 
    
    for(i=0;i<3;i++)
    {
      error = RCToDeg(RC[i+1]) - omega[i];
      Ipart[i] += error*Dt;
      Ipart[i] = constrain(Ipart[i],-20,20);
      Dpart[i] = (omega[i] - oldomega[i])/float(Dt);
      oldomega[i]=omega[i];
      axisPID[i] = Pgain[i]*error + Dgain[i]*Dpart[i] + Igain[i]*Ipart[i]; 
    }
  PIDToMotor();

   
/*for(int j=0;j<4;j++)
  {
    Serial.print(motor[j]);  
    Serial.print("\t");
  }
  Serial.println();*/
 
   if (failsafe())
   WriteRC();
   else WriteNull();
   
}

